#ifndef NetWorkDLS_LZARI_Data_Compression_Decompression
#define NetWorkDLS_LZARI_Data_Compression_Decompression
///////////////////////////////////////////////////////////////////////////////////////////

#include "Headers/Compression.H"

int LZARIDecompress(char *SourceFileName, char *TargetFileName)
{
    int  i=0, j=0, k=0, r=0, c=0;
    long int PrintCount = 0, TextSize = 0;

    DWORD SourceFileSize = 0;
    long double Current_Size = 0;

    Initialize();

    if((CompressSource = fopen(SourceFileName,"rb")) == NULL)
    {
        printf("Compression: Could Not Open Source File.");
        if(CompressSource)fclose(CompressSource);
        return 0;
    }

    if((CompressTarget = fopen(TargetFileName,"wb")) == NULL)
    {
        printf("Compression: Could Not Open Target File.");
        if(CompressTarget)fclose(CompressTarget);
        return 0;
    }

    /* read size of text */
    if(fread(&TextSize, sizeof(TextSize), 1, CompressSource) < 1)
    {
        printf("Compression: File Read Error.");
        return 0;
    }

    if(TextSize == 0) return 0;
    SourceFileSize = TextSize;

    StartDecode();
    StartModel();

    for(i = 0; i < SizeOfRingBuffer - MatchLengthLimit; i++) TextBuffer[i] = '\0';

    r = SizeOfRingBuffer - MatchLengthLimit;

    for(Current_Size = 0; Current_Size < TextSize; )
    {
        c = DecodeChar();
        if (c < 256)
        {
            putc(c, CompressTarget);
            TextBuffer[r++] = c;
            r &= (SizeOfRingBuffer - 1);
            Current_Size++;
        }
        else{
            i = (r - DecodePosition() - 1) & (SizeOfRingBuffer - 1);
            j = c - 255 + THRESHOLD;

            for (k = 0; k < j; k++)
            {
                c = TextBuffer[(i + k) & (SizeOfRingBuffer - 1)];
                putc(c, CompressTarget);
                TextBuffer[r++] = c;
                r &= (SizeOfRingBuffer - 1);
                Current_Size++;
            }
        }

        PrintCount++;
        if(PrintCount == 10240)
        {
            PI.StatusValue = ((Current_Size / SourceFileSize) * 100);
            PrintCount = 0;
            if(PI.SaveCPUOption) Sleep(10);
        }

        if(PI.CancelFlag == TRUE)
        {
            if(CompressSource)fclose(CompressSource);
            if(CompressTarget)fclose(CompressTarget);
            return 1;
        }
    }

    /* Update Status One Last Time */
    PI.StatusValue = ((Current_Size / SourceFileSize) * 100);

    if(CompressSource)fclose(CompressSource);
    if(CompressTarget)fclose(CompressTarget);

    Sleep(250);

    return 1;
}

///////////////////////////////////////////////////////////////////////////////////////////
#endif

