///////////////////////////////////////////////////////////////////////

int BlowFishEncode(char *SourceName,char *TargetName, char *Key)
{
    unsigned long L = 1, R = 3, RemLong = 0, FileSize = 0;
    FILE *Source = NULL, *Target = NULL;

    double Process_FileSize, EncodeLoop;
    int StatusCount   = 0;

    // Create BlowFish Object
    BF_BlowFish((unsigned char*)Key, strlen(Key));

    FileSize = Get_FileSize(SourceName);

    if (FileSize == 0)
    {
        Error("BlowFish: File Contains No Data.");
        if(Source)fclose(Source);
        return 0;
    }

    /* RemLong Is The Ammount Of Bits Added To The End Of The Encrypted
    File To Make The FileSize mod 8 = 0, These Bits Are Later Removed */
    RemLong = (FileSize % 8);

    //Open Files
    if((Source = fopen(SourceName,"rb")) == NULL)
    {
        Error("BlowFish: Could Not Open File For Read.");
        if(Source)fclose(Source);
        return 0;
    }

    // Seek To End Of File
    fseek(Source,0,SEEK_END);

    // Get byte position (File Size)
    FileSize = ftell(Source);

    // Calculate How Many Sets Of 8 For Encryption Loop
    Process_FileSize = (FileSize/sizeof(L))/2;

    // Seek Back To The Beginning
    fseek(Source,0,SEEK_SET);

    //Write And Read Header This Allows The Coder To Check The Key
    //Before Decryption The File
    if((Target = fopen(TargetName,"wb")) == NULL)
    {
        Error("BlowFish: Could Not Open File For Write.");
        if(Source)fclose(Source);
        if(Target)fclose(Target);
        return 0;
    }

    /*  PI.FileFlagResult
        1: Pack, Encrypt Directory
        2: Pack, Compress, Encrypt Directory
        3: Encrypt File
        4: Compressed, Encrypted File
    */

    if(PI.FileFlagResult == 1) fprintf(Target,"%s",PACFlag);
    if(PI.FileFlagResult == 2) fprintf(Target,"%s",PACCompress);
    if(PI.FileFlagResult == 3) fprintf(Target,"%s",ENCFlag);
    if(PI.FileFlagResult == 4) fprintf(Target,"%s",ENCCompress);

    //Write Header 84082311328048 128-Bit
    //On Decryption This Is Decrypted Using The Provided Key
    //And Checked Against Value 84082311328048 To See If The
    //Correct Key Was Used

    L = 15942653;
    R = 18753826;

    //Encrypt Header
    BF_Encrypt(&L, &R);

    //Write Header
    fwrite((char *)&L, sizeof(L), 1, Target);
    fwrite((char *)&R, sizeof(R), 1, Target);

    // Write Header Containing The Number Of Bits Added (Rem)
    fwrite((char *)&RemLong, 4, 1, Target);

    Process_FileSize++; // Add 1 To Process_FileSize

    // Begin Encryption / Decryption
    for(EncodeLoop = 0; EncodeLoop < Process_FileSize; EncodeLoop++)
    {
        // Read 8 Bytes From File
        fread((char *)&L, sizeof(L), 1, Source);
        fread((char *)&R, sizeof(R), 1, Source);

        // Call blowfish.cpp Functions
        BF_Encrypt(&L, &R);

        // Write 8 Bytes To File

        fwrite((char *)&L, sizeof(L), 1, Target);
        fwrite((char *)&R, sizeof(R), 1, Target);

        StatusCount++;
        if(StatusCount == 10240)
        {
            PI.StatusValue = (EncodeLoop/(Process_FileSize-1)) * 100;
            StatusCount = 0;
            if(PI.SaveCPUOption) Sleep(10);
        }

        if(PI.CancelFlag == TRUE)
        {
            if(Source)fclose(Source);
            if(Target)fclose(Target);
            return 1;
        }
    }

    PI.StatusValue = (EncodeLoop / (Process_FileSize-1)) * 100;

    //Close Files
    if(Source)fclose(Source);
    if(Target)fclose(Target);

    Sleep(250);

    return 1;
}
