#ifndef NetWorkDLS_Package_UnPackFile_SourceFile
#define NetWorkDLS_Package_UnPackFile_SourceFile

#include "Package.H"

////////////////////////////////////////////////////////////////////////////////////////////

int UnPackFiles(char *SourceFile, char *DestinationDir)
{
    FILE *LocalTarget = NULL;
    FILE *LocalSource = NULL;

    char *ReadTemp    = NULL;
    char *LocalBuffer = NULL;
    char FolderName[257];
    char StatusText[257];

    char TargetFileName[1024];

    float xFileCount  = 0;
    float xLocalLoop  = 0;

    DWORD LocalLoop   = 0;

    int CurrentBuffer = 0;
    int NameLenTemp   = 0;
    int NeededMemory  = 0;

    long double SourceFileSize = 0;
    long double FileSizeLeft   = 0;
    long double Current_Size   = 0;
    int StatusCount            = 0;

    /* Open Source File */
    if((LocalSource = fopen(SourceFile,"rb")) == NULL)
    {
        if(LocalSource)fclose(LocalSource);
        Error("UnPackFiles: Could Not Open File For Read.\n");
        return 0;
    }

    /* Get Number Of Files  (DWORD FileCount) */
    ReadTemp = (char *)calloc(7,1);
    fread(ReadTemp,sizeof(char),6,LocalSource);
    Package.FileCount = atol(ReadTemp);
    if(ReadTemp)free(ReadTemp);
    fseek(LocalSource,1,SEEK_CUR);

    /* Get Number Of Folders  (DWORD FolderCount) */
    ReadTemp = (char *)calloc(7,1);
    fread(ReadTemp,sizeof(char),6,LocalSource);
    Package.FolderCount = atol(ReadTemp);
    if(ReadTemp)free(ReadTemp);
    fseek(LocalSource,1,SEEK_CUR);

    /* Get FileNames ( *FileNames[] )*/
    LocalLoop = 0;
    while(LocalLoop < Package.FileCount)
    {
        ReadTemp = (char *)calloc(4,1);
        fread(ReadTemp,sizeof(char),3,LocalSource);
        NameLenTemp = atoi(ReadTemp);
        if(ReadTemp)free(ReadTemp);

        ReadTemp = (char *)calloc(NameLenTemp+1,1);
        fread(ReadTemp,sizeof(char),NameLenTemp,LocalSource);
        NeededMemory = NameLenTemp + 10;
        Package.FileNames[LocalLoop] = (char *) calloc(NeededMemory,1);
        sprintf(Package.FileNames[LocalLoop],"%s",ReadTemp);
        if(ReadTemp)free(ReadTemp);

        LocalLoop++;
    }
    fseek(LocalSource,1,SEEK_CUR);

    /* Get FolderNames ( *FolderNames[] )*/
    LocalLoop = 0;
    while(LocalLoop < Package.FolderCount)
    {
        ReadTemp = (char *)calloc(4,1);
        fread(ReadTemp,sizeof(char),3,LocalSource);
        NameLenTemp = atoi(ReadTemp);
        if(ReadTemp)free(ReadTemp);

        ReadTemp = (char *)calloc(NameLenTemp+1,1);
        fread(ReadTemp,sizeof(char),NameLenTemp,LocalSource);
        NeededMemory = NameLenTemp + 10;
        Package.FolderNames[LocalLoop] = (char *) calloc(NeededMemory,1);
        sprintf(Package.FolderNames[LocalLoop],"%s",ReadTemp);
        if(ReadTemp)free(ReadTemp);

        LocalLoop++;
    }
    fseek(LocalSource,1,SEEK_CUR);

    /* Create Folders */
    LocalLoop = 0;
    Set_Text(PI.StatusText_hWnd, "Creating Folders");

    CreateDirectory(DestinationDir,0);

    while(LocalLoop < Package.FolderCount) // Print Folder Names
    {
        sprintf(FolderName,"%s\\%s",DestinationDir,Package.FolderNames[LocalLoop]);
        CreateDirectory(FolderName,0);
        LocalLoop++;
    }

    sprintf(StatusText, "UnPacking %d Files && %d Folders",Package.FileCount,Package.FolderCount);
    Set_Text(PI.StatusText_hWnd, StatusText);

    xFileCount = (float)Package.FileCount;

    // Write Data To Files (Begin)
    LocalLoop = 0;
    while(LocalLoop < Package.FileCount)
    {
        sprintf(TargetFileName,"%s\\%s",DestinationDir,Package.FileNames[LocalLoop]);

        /* Open Target File */
        if((LocalTarget = fopen(TargetFileName,"wb")) == NULL)
        {
            if(LocalTarget)fclose(LocalTarget);
            if(LocalSource)fclose(LocalSource);
            Error("UnPackFiles: Could Not Open File For Write.");
            return 0;
        }

        Current_Size   = 0;
        SourceFileSize = 0;
        FileSizeLeft   = 0;

        /* Get Size Of File */
        ReadTemp = (char *)calloc(10,1);
        fread(ReadTemp,sizeof(char),9,LocalSource);
        SourceFileSize = atol(ReadTemp);
        if(ReadTemp)free(ReadTemp);

        Current_Size = 0;

        if(PI.CancelFlag == TRUE)
        {
            if(LocalTarget)fclose(LocalTarget);
            if(LocalSource)fclose(LocalSource);
            return 1;
        }

         // If File Can Be Completed In One Buffer
        if(SourceFileSize < BufferSize)
        {
            LocalBuffer = (char *) calloc((int)SourceFileSize+1,1);
            fread(LocalBuffer,sizeof(char),(int)SourceFileSize,LocalSource);
            fwrite(LocalBuffer,sizeof(char),(int)SourceFileSize,LocalTarget);
            if(LocalBuffer)free(LocalBuffer);
        }
        else{ // Else If File Bigger Than Buffer
            while(Current_Size < SourceFileSize)
            {
                FileSizeLeft = SourceFileSize - Current_Size;

                /* If File Can Be Completed In One Buffer */
                if(FileSizeLeft < BufferSize)
                {
                    LocalBuffer = (char *) calloc((int)FileSizeLeft+1,1);
                    fread(LocalBuffer,sizeof(char),(int)FileSizeLeft,LocalSource);
                    fwrite(LocalBuffer,sizeof(char),(int)FileSizeLeft,LocalTarget);
                    Current_Size += FileSizeLeft;
                    if(LocalBuffer)free(LocalBuffer);
                    break;
                }

                LocalBuffer = (char *) calloc(BufferSize+1,1);
                CurrentBuffer = fread(LocalBuffer,sizeof(char),BufferSize,LocalSource);
                fwrite(LocalBuffer,sizeof(char),CurrentBuffer,LocalTarget);
                if(LocalBuffer)free(LocalBuffer);
                Current_Size += BufferSize;
                if(PI.SaveCPUOption) Sleep(1);
            }

        }
        if(LocalTarget)fclose(LocalTarget);

        LocalLoop++;

        StatusCount++;
        if(StatusCount == 5)
        {
            xLocalLoop  = (float)LocalLoop;
            PI.StatusValue = ((xLocalLoop / xFileCount) * 100);
            StatusCount = 0;
        }
    }
    // Write Data To Files (End)

    xLocalLoop  = (float)LocalLoop;
    PI.StatusValue = ((xLocalLoop / xFileCount) * 100);

    FreeMemory();

    if(LocalTarget)fclose(LocalTarget);
    if(LocalSource)fclose(LocalSource);

    Sleep(250);

    return 1;
}

////////////////////////////////////////////////////////////////////////////////////////////
#endif

