// RSMenu.h : Declaration of the CRSMenu

#ifndef __RSMENU_H_
#define __RSMENU_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CRSMenu
class ATL_NO_VTABLE CRSMenu : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CRSMenu, &CLSID_RSMenu>,
	public IShellExtInit,
	public IContextMenu,
	public IDispatchImpl<IRSMenu, &IID_IRSMenu, &LIBID_RSCONTEXTLib>
{
public:
	CRSMenu()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_RSMENU)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CRSMenu)
	COM_INTERFACE_ENTRY(IRSMenu)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IShellExtInit)
	COM_INTERFACE_ENTRY(IContextMenu)
END_COM_MAP()

	// IContextMenu
	STDMETHOD(GetCommandString)(UINT idCmd, UINT uFlags, UINT *pwReserved, 
								LPSTR pszName, UINT cchMax);
	STDMETHOD(InvokeCommand)(LPCMINVOKECOMMANDINFO pici);
	STDMETHOD(QueryContextMenu)(HMENU hmenu, UINT indexMenu, 
								UINT idCmdFirst, UINT idCmdLast, 
								UINT uFlags);

	// IShellExtInit
	STDMETHOD(Initialize)(LPCITEMIDLIST pidlFolder, LPDATAOBJECT lpdobj, 
							HKEY hkeyProgID);


// IRSMenu
public:
	TCHAR	m_szFile[MAX_PATH];
};

#endif //__RSMENU_H_
