#include "Headers/BlowFish.H"

//---------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////

int BlowFish_Interface(char *SourceName,char *TargetName, char *Key, int EFlag)
{
    unsigned long L = 1, R = 3, RemLong, FileSize, Process_FileSize;
    FILE *Source, *Target;
    DWORD i;
    float StatusValue = 0;

    // Create BlowFish object from blowfish.cpp
    BF_BlowFish((unsigned char*)Key, strlen(Key));

    //Open Files
    if((Source = fopen(SourceName,"rb")) == NULL)
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"Could Not Open %s For Read. Error 21.",SourceName);
        ReportError(ErrorTemp);
        if(Source)fclose(Source);
        return 1;
    }

    // Seek to end of file
    fseek(Source,0,SEEK_END);

    // Get byte position (File Size)
    FileSize = ftell(Source) - ExecutableEnd;

    // Calculate how many sets of 8 for encryption loop
    Process_FileSize = (FileSize/sizeof(L))/2;

    // Seek back to the beginning
    fseek(Source,ExecutableEnd+FlagLenght,SEEK_SET); // Seek Past Executable

    //Write and read header this allows the coder to check the key
    //before decryption the file

    Process_FileSize--;

    // Read and compare header <nept35>
    fread((char *)&L, sizeof(L), 1, Source);
    fread((char *)&R, sizeof(R), 1, Source);

    //Decrypt header
    BF_Decrypt(&L, &R);

    /* Compare if decrypted correctly,
    If not so tell user wrong key */

    if (L != 15942653 || R != 18753826)
    {
        SetText(StatusText_hWnd,"Wrong Key, Can't Decrypt");
        if(Source)fclose(Source);
        return 3;
    }

    if((Target = fopen(TargetName,"wb")) == NULL)
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"Could Not Open %s For Write. Error 22.",SourceName);
        ReportError(ErrorTemp);
        if(Source)fclose(Source);
        if(Target)fclose(Target);
        return 4;
    }

    // Because header does not count suptract one
    Process_FileSize--;

    // Read second header containing Rem
    fread((char *)&RemLong, 4, 1, Source);

    unsigned long CurrentByte;
    long double Current_Size;
    DWORD SourceFileSize;
    DWORD EndOfFile;

    CurrentByte = ftell(Source);
    fseek(Source,0,SEEK_END);
    EndOfFile = ftell(Source);
    fseek(Source,CurrentByte,SEEK_SET);
    SourceFileSize = EndOfFile - CurrentByte;
    Current_Size = 0;

    DWORD PrintCount = 0;

    // Begin encryption
    for(i=0; i < Process_FileSize; i++)
    {
        Current_Size += 8;
        PrintCount +=8;
        if(PrintCount == 1024)
        {
            StatusValue = (float)((Current_Size / SourceFileSize) * 100);
            SendMessage(StatusBar_hWnd, PBM_SETPOS,(DWORD)StatusValue,0);
            PrintCount = 0;
        }

        if(CancelFlag)
        {
            if(Source)fclose(Source);
            if(Target)fclose(Target);
            return 5;
        }

        // Read 8 bytes from file
        fread((char *)&L, sizeof(L), 1, Source);
        fread((char *)&R, sizeof(R), 1, Source);

        // Call blowfish.cpp Functions
        if (EFlag == 3)
            BF_Encrypt(&L, &R);
        else BF_Decrypt(&L, &R);

        // Write 8 bytes to file
        if (i==Process_FileSize-1 && EFlag==1)
        {
            if (RemLong < 4)
            {
                fwrite((char *)&L, (RemLong), 1, Target);
            }
            else {
                fwrite((char *)&L, sizeof(L), 1, Target);
                fwrite((char *)&R, sizeof(R) - (8-RemLong), 1, Target);
            }
        }
        else {
            fwrite((char *)&L, sizeof(L), 1, Target);
            fwrite((char *)&R, sizeof(R), 1, Target);
        }
    }

    // Update StatusBar One More Time
    StatusValue = (float)((Current_Size / SourceFileSize) * 100);
    SendMessage(StatusBar_hWnd, PBM_SETPOS,(DWORD)StatusValue,0);

    //close files
    if(Source)fclose(Source);
    if(Target)fclose(Target);

    return 0;
}
