/*

 UnPackFiles.H - Functions Used To Unpack Files From A Single File

*/

////////////////////////////////////////////////////////////////////////

int UnPackFiles(char *SourceFile, char *DestinationDir)
{
	FILE *LocalTarget = NULL;
	FILE *LocalSource = NULL;

	char *ReadTemp	  = NULL;
	char *LocalBuffer = NULL;

	char StatusString[1024];
	char LocalTemp[1024];

	float xFileCount = 0;
	float xLocalLoop = 0;

	DWORD LocalLoop = 0;
	float StatusValue = 0;

	int CurrentBuffer = 0;
	int NameLenTemp = 0;
	int NeededMemory = 0;

	long double SourceFileSize = 0;
	long double FileSizeLeft = 0;
	long double Current_Size = 0;

	/* Open Source File */
	if((LocalSource = fopen(SourceFile,"rb")) == NULL)
	{
		if(LocalSource)fclose(LocalSource);
		ReportError("Unpack Error: Cannot Read Source.");
		return 1;
	}

	/* Create Directory (Log It After Log Files Open) */
	CreateDirectory(DestinationDir,0);

	/* Get Number Of Files	(DWORD FileCount) */
	ReadTemp = (char *)calloc(7,1);
	fread(ReadTemp,sizeof(char),6,LocalSource);
	Package.FileCount = atol(ReadTemp);

	if(Package.FileCount < 1)
	{
		ReportError("Unpack Error: Package Contains No Files.");
		return 7;
	}

	xFileCount = (float)Package.FileCount;

	fseek(LocalSource,1,SEEK_CUR);

	/* Get Number Of Folders  (DWORD FolderCount) */
	ReadTemp = (char *)calloc(7,1);
	fread(ReadTemp,sizeof(char),6,LocalSource);
	Package.FolderCount = atol(ReadTemp);

	fseek(LocalSource,1,SEEK_CUR);

	/* Get FileNames ( *FileNames[] )*/
	LocalLoop = 0;
	while(LocalLoop < Package.FileCount)
	{
		ReadTemp = (char *)calloc(4,1);
		fread(ReadTemp,sizeof(char),3,LocalSource);
		NameLenTemp = atoi(ReadTemp);
		ReadTemp = (char *)calloc(NameLenTemp+1,1);
		fread(ReadTemp,sizeof(char),NameLenTemp,LocalSource);
		NeededMemory = NameLenTemp + 10;
		Package.FileNames[LocalLoop] = (char *) calloc(NeededMemory,1);
		sprintf(Package.FileNames[LocalLoop],"%s",ReadTemp);

		LocalLoop++;
	}

	fseek(LocalSource,1,SEEK_CUR);

	/* Get FolderNames ( *FolderNames[] )*/
	LocalLoop = 0;
	while(LocalLoop < Package.FolderCount)
	{
		ReadTemp = (char *)calloc(4,1);
		fread(ReadTemp,sizeof(char),3,LocalSource);
		NameLenTemp = atoi(ReadTemp);
		ReadTemp = (char *)calloc(NameLenTemp+1,1);
		fread(ReadTemp,sizeof(char),NameLenTemp,LocalSource);
		NeededMemory = NameLenTemp + 10;
		Package.FolderNames[LocalLoop] = (char *) calloc(NeededMemory,1);
		sprintf(Package.FolderNames[LocalLoop],"%s",ReadTemp);

		LocalLoop++;
	}

	sprintf(StatusString,"Package Contains %d Files && %d Folders \r\n \r\n",Package.FileCount,Package.FolderCount);
	SetText(StatusText_hWnd,StatusString);

	/* Create Folders */
	LocalLoop = 0;

//	  if(Package.FolderCount > 0)
//		  SetText(StatusText_hWnd,"Creating Folders...");

	while(LocalLoop < Package.FolderCount) // Create Folders
	{
		sprintf(LocalTemp,"%s\\%s",DestinationDir,Package.FolderNames[LocalLoop]);
		CreateDirectory(LocalTemp,0);
		LocalLoop++;
	}

	fseek(LocalSource,1,SEEK_CUR);

	// Create And Write Data To Files (Begin)
	LocalLoop = 0;
	while(LocalLoop < Package.FileCount)
	{
		sprintf(LocalTemp,"%s\\%s",DestinationDir,Package.FileNames[LocalLoop]);

		Current_Size = 0;
		SourceFileSize = 0;
		FileSizeLeft = 0;
		Current_Size = 0;

		/* Get Size Of File */
		ReadTemp = (char *)calloc(10,1);
		fread(ReadTemp,sizeof(char),9,LocalSource);
		SourceFileSize = atol(ReadTemp);

		/* Print Status */
//		  sprintf(StatusString,"(%d)Installing: %s \r\n",LocalLoop+1,Package.FileNames[LocalLoop]);
//		  SetText(StatusText_hWnd,StatusString);

		/* Open Target File */
		if((LocalTarget = fopen(LocalTemp,"wb")) == NULL)
		{
			if(LocalTarget)fclose(LocalTarget);
			ReportError("Unpack Error: Cannot Write Target.");
			return 4;
		}

		if(CancelFlag)
		{
			if(LocalTarget)fclose(LocalTarget);
			if(LocalSource)fclose(LocalSource);
			return 5;
		}

		// If File Can Be Copied In One Buffer
		if(SourceFileSize < BufferSize)
		{
			LocalBuffer = (char *)calloc((DWORD)SourceFileSize+1,1);
			fread(LocalBuffer,sizeof(char),(DWORD)SourceFileSize,LocalSource);
			fwrite(LocalBuffer,sizeof(char),(DWORD)SourceFileSize,LocalTarget);
			if(LocalBuffer)free(LocalBuffer);
		}
		else { // Else If File Bigger Than Buffer
			while(Current_Size < SourceFileSize)
			{
				FileSizeLeft = SourceFileSize - Current_Size;

				/* If File Can Be Completed In One Buffer */
				if(FileSizeLeft < BufferSize)
				{
					LocalBuffer = (char *)calloc((DWORD)FileSizeLeft+1,1);
					fread(LocalBuffer,sizeof(char),(DWORD)FileSizeLeft,LocalSource);
					fwrite(LocalBuffer,sizeof(char),(DWORD)FileSizeLeft,LocalTarget);
					if(LocalBuffer)free(LocalBuffer);
					Current_Size += FileSizeLeft;
					break;
				}

				LocalBuffer = (char *)calloc(BufferSize+1,1);
				CurrentBuffer = fread(LocalBuffer,sizeof(char),BufferSize,LocalSource);
				fwrite(LocalBuffer,sizeof(char),CurrentBuffer,LocalTarget);
				if(LocalBuffer)free(LocalBuffer);
				Current_Size += BufferSize;
			}
		}

		if(LocalTarget)fclose(LocalTarget);

		LocalLoop++;
		xLocalLoop = (float)LocalLoop;

		StatusValue = (xLocalLoop / xFileCount) * 100;
		SendMessage(StatusBar_hWnd, PBM_SETPOS,(DWORD)StatusValue,0);
	}
	// Create And Write Data To Files (End)

	FreeMemory();

	if(LocalTarget)fclose(LocalTarget);
	if(LocalSource)fclose(LocalSource);

	return 0;
}

///////////////////////////////////////////////////////////////////////

