/////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <WindowsX.H>
#include <CommCTRL.H>
#include <ShellAPI.H>
#include <Stdio.H>
#include <StdLib.H>
#include <IO.H>

#include "Headers/Definitions.H"
#include "Headers/LZARI.H"
#include "Headers/DeleteObject.H"
#include "Headers/Functions.H"

#include "Headers/Interface.H"
#include "Headers/448Coding.H"

#include "Headers/UnPackFiles.H"

#include "Dialogs/MainDialog.H"
#include "Dialogs/StatusDialog.H"
#include "Dialogs/AboutDialog.H"

/////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevious, LPSTR Cmd , int CmdShow)
{
    HANDLE xMutex;

    if( (xMutex = OpenMutex(SYNCHRONIZE, FALSE, TitleCaption)) )
    {
        MessageBox (NULL, "Only One Instance Can Be Run At A Time!" , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
        ReleaseMutex(xMutex);
        CloseHandle(xMutex);
        return 0;
    }
    xMutex = CreateMutex(0, FALSE, TitleCaption);

    hInstance = hInst;
    GetModuleFileName(NULL,SourceFileName,1024);

    if(Get_FileSize(SourceFileName) == ExecutableEnd)
    {
        MessageBox (NULL, "Package Contains No Data!" , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
        ReleaseMutex(xMutex);
        CloseHandle(xMutex);
        return 0;
    }

    char Drive[256];
    char Directory[256];
    char File[256];

    _splitpath(SourceFileName,Drive,Directory,File,NULL);
    _makepath(Package.TargetDir,Drive,Directory,File,NULL);

    DialogBox(hInstance,MAKEINTRESOURCE(100),0,MainDialog);

    ReleaseMutex(xMutex);
    CloseHandle(xMutex);

    return 0;
}

/////////////////////////////////////////////////////////////////////

