[Setup]
;-- Main Setup Information
 AppName                 = 448Delta Encryption
 AppVerName              = 448Delta 1.0.2.5
 AppCopyright            = Copyright  1995-2002 NetWorkDLS, Inc.
 DefaultDirName          = {pf}\NetWorkDLS\448Delta
 DefaultGroupName        = NetWorkDLS\448Delta
 UninstallDisplayIcon    = {app}\448Delta.Exe
 UninstallStyle          = Modern
 WizardSmallImageFile    = Resources\448Logo.Bmp
 WizardImageFile         = Resources\NetSetup.Bmp
 AppMutex                = 448Delta Encryption
 AdminPrivilegesRequired = Yes
 MinVersion              = 4.0.1381,4.1
 Uninstallable           = Yes
 LicenseFile             = Resources\EULA.txt
 Compression             = ZIP/9
;AlwaysRestart=yes
 
;-- Windows 2000 & XP (Support Dialog)
 AppPublisher    = NetWorkDLS
 AppPublisherURL = http://www.NetWorkDLS.com/
 AppUpdatesURL   = http://www.NetWorkDLS.com/
 AppVersion      = 1.0.2.5

[Run]
Filename: "RegSvr32"; Parameters: " /s ""{app}\448Context.Dll"""

[Types]
 Name: "Full"; Description: "Full installation"
 Name: "Compact"; Description: "Compact installation"
 Name: "Custom"; Description: "Custom installation"; Flags: iscustom

[Components]
 Name: "Main"; Description: "Main Files";     Types: Full Compact Custom; Flags: fixed;
 Name: "DLL";  Description: "448Delta DLL's"; Types: Full Compact Custom; Flags: fixed;
 Name: "Help"; Description: "Help File";      Types: Full Custom;
 Name: "SelfExe";    Description: "Self Extract Support";         Types: Full;
 Name: "Thread";     Description: "Advanced Threading Support";   Types: Full;

[Files]
 Source: "..\Debug\448Delta.Exe";                     DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "Resources\MenuIcon.Bmp";                    DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "448Context\Release\448Context.DLL";         DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main; Flags: regserver restartreplace
 Source: "Resources\EULA.txt";                        DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Main
 Source: "Help\448Delta.Chm";                         DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Help
 Source: "SelfAppend\Release\SelfAppend.Exe";         DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: SelfExe
 Source: "SelfExtract\Release\SelfExtract.Exe";       DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: SelfExe
 Source: "448Priority\Release\448Priority.Exe";       DestDir: "{app}"; CopyMode: "alwaysoverwrite"; Components: Thread

 Source: "Libraries\NSWFL.Dll"; DestDir: "{app}";  CopyMode: "alwaysoverwrite"; Components: DLL

[Icons]
 Name: "{group}\448Delta Help";      Filename: "{app}\448Delta.Chm";    Components: Help
 Name: "{group}\Set Priority";       Filename: "{app}\448Priority.Exe"; Components: Thread
 Name: "{group}\Uninstall";          Filename: "{app}\Unins000.Exe";    Components: Main

[Registry]
;-- Create 448Delta "Single File" Association
 Root: HKCR; Subkey: ".448"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: ".448"; ValueType: string;  ValueData: "448File"
 Root: HKCR; Subkey: "448File"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448File"; ValueType: string;  ValueName: "NeverShowExt"; ValueData:""
 Root: HKCR; Subkey: "448File"; ValueType: string;  ValueData:"448Delta Encrypted File"
 Root: HKCR; Subkey: "448File\Shell\Open\Command"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448File\Shell\Open\Command"; ValueType: string;  ValueData:"""{app}\448Delta.Exe"" %1"
 Root: HKCR; Subkey: "448File\DefaultIcon"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448File\DefaultIcon"; ValueType: string;  ValueData:"{app}\448Delta.Exe,1"

 Root: HKCR; Subkey: "448File\Shell\CreateSelf"; ValueType: string;  ValueData: "Create Self Extractor"; Components: SelfExe
 Root: HKCR; Subkey: "448File\Shell\CreateSelf\Command"; Flags: uninsdeletekey noerror; Components: SelfExe
 Root: HKCR; Subkey: "448File\Shell\CreateSelf\Command"; ValueType: string;  ValueData:"""{app}\SelfAppend.Exe"" %1"; Components: SelfExe

;-- Create 448Delta "Package File" Association
 Root: HKCR; Subkey: ".448Pkg"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: ".448Pkg"; ValueType: string;  ValueData: "448PkgFile"
 Root: HKCR; Subkey: "448PkgFile"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448PkgFile"; ValueType: string;  ValueName: "NeverShowExt"; ValueData:""
 Root: HKCR; Subkey: "448PkgFile"; ValueType: string;  ValueData:"448Delta Encrypted Package"
 Root: HKCR; Subkey: "448PkgFile\Shell\Open\Command"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448PkgFile\Shell\Open\Command"; ValueType: string;  ValueData:"""{app}\448Delta.Exe"" %1"
 Root: HKCR; Subkey: "448PkgFile\DefaultIcon"; Flags: uninsdeletekey noerror;
 Root: HKCR; Subkey: "448PkgFile\DefaultIcon"; ValueType: string;  ValueData:"{app}\448Delta.Exe,3"

 Root: HKCR; Subkey: "448PkgFile\Shell\CreateSelf"; ValueType: string;  ValueData: "Create Self Extractor"; Components: SelfExe
 Root: HKCR; Subkey: "448PkgFile\Shell\CreateSelf\Command"; Flags: uninsdeletekey noerror; Components: SelfExe
 Root: HKCR; Subkey: "448PkgFile\Shell\CreateSelf\Command"; ValueType: string;  ValueData:"""{app}\SelfAppend.Exe"" %1"; Components: SelfExe

;-- Create Path Keys For Use Within 448Delta
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path";
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path"; ValueType: string;  ValueName: "Path";          ValueData:"{app}"
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path"; ValueType: string;  ValueName: "SelfExtract";   ValueData:"{app}\SelfExtract.Exe"
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path"; ValueType: string;  ValueName: "SelfAppend";    ValueData:"{app}\SelfAppend.Exe"
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path"; ValueType: string;  ValueName: "448Delta";      ValueData:"{app}\448Delta.Exe"
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path"; ValueType: string;  ValueName: "HelpPath";      ValueData:"{app}\448Delta.Chm"
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Path"; ValueType: string;  ValueName: "MenuIcon";      ValueData:"{app}\MenuIcon.Bmp"

;-- Create Dialog Information Keys For Use Within 448Delta
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\DecryptDialog"; ValueType: dword;  ValueName: "DeleteSourceOption"; ValueData:0
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\DecryptDialog"; ValueType: dword;  ValueName: "DestroyTempOption";  ValueData:1
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\DecryptDialog"; ValueType: dword;  ValueName: "SaveCPUOption";      ValueData:0
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\DecryptDialog"; ValueType: dword;  ValueName: "TopMost";            ValueData:1
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\DecryptDialog"; ValueType: dword;  ValueName: "UsePriorityOption";  ValueData:1

 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "CompressOption";     ValueData:0
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "CreateSelfOption";   ValueData:0
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "DeleteSourceOption"; ValueData:0
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "DestroyTempOption";  ValueData:1
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "SaveCPUOption";      ValueData:0
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "TopMost";            ValueData:1
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\EncryptDialog"; ValueType: dword;  ValueName: "UsePriorityOption";  ValueData:1

 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\StatusDialog";  ValueType: dword;  ValueName: "TopMost";            ValueData:1

;-- Create Version Keys For Use Within 448Delta
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Version"; ValueType: string;  ValueName: "Version"; ValueData:"1.0.2.5"

;-- Create Priority Keys For Use Within 448Delta
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Priority"; ValueType: dword;  ValueName: "ProcessBoost"; ValueData:1
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Priority"; ValueType: dword;  ValueName: "ThreadBoost";  ValueData:1
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Priority"; ValueType: dword;  ValueName: "Process";      ValueData:2
 Root: HKLM; Subkey: "Software\NetWorkDLS\448Delta\\Priority"; ValueType: dword;  ValueName: "Thread";       ValueData:4

